package Pair;

/**
 * You need to store two values of type `E`, set them in a constructor, and have the following methods,
 * getFirst
 * getSecond
 * min -> returns the minimum of the pair
 * max -> returns the maximum of the pair
 */
public class Pair<E extends Comparable>{
    private E first;
    private E second;

    public Pair() {
        first = null;
        second = null;
    }

    public Pair(E first, E second) {
        this.first = first;
        this.second = second;
    }

    public E getFirst() { return first; }
    public E getSecond() { return second; }

    public void setFirst(E newValue) { this.first = newValue; }
    public void setSecond(E newValue) { this.second = newValue; }

    public <E> E min() {
        first = getFirst();
        second = getSecond();
        if(first.compareTo(second) < second.compareTo(first)) {
            return (E)first;
        }
        return (E)second;
    }

    public <E> E max() {
        first = getFirst();
        second = getSecond();
        if(first.compareTo(second) > second.compareTo(first)) {
            return (E) first;
        }
        return (E)second;
    }
}
